/*
 * Copyright (c) 2019 Adrian Siekierka
 *
 * This file is part of Redstone Minus Redstone.
 *
 * Redstone Minus Redstone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Redstone Minus Redstone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Redstone Minus Redstone.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.redstoneminus;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IWorldEventListener;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;
import net.minecraftforge.energy.CapabilityEnergy;
import net.minecraftforge.energy.IEnergyStorage;

import javax.annotation.Nullable;

public class EnergyWorldTrackerEveryone implements IEnergyWorldTracker {
	private final PowerTicker ticker = new PowerTicker();
	private final World world;
	private boolean added;

	public EnergyWorldTrackerEveryone(World world) {
		this.world = world;
	}

	public void register() {
		if (!added) {
			added = true;
		}
	}

	public void unregister() {
		if (added) {
			added = false;
		}
	}

	@Override
	public void chunkLoaded(Chunk chunk) {

	}

	@Override
	public void chunkUnloaded(Chunk chunk) {

	}

	public void tick() {
		int[] ramp = ticker.tickRamp(RedstoneMinusRedstone.powerRamp);
		if (ramp == null) {
			return;
		}

		// Work around the potential for a CME, even if we end up skipping a tile or two.
		int len = world.field_147482_g.size();
		for (int i = 0; i < len; i++) {
			TileEntity tile;
			try {
				tile = world.field_147482_g.get(i);
			} catch (Throwable t) {
				break;
			}

			RedstoneMinusHelpers.tick(world, tile, ramp);
		}
	}
}
