/*
 * Copyright (c) 2019 Adrian Siekierka
 *
 * This file is part of Redstone Minus Redstone.
 *
 * Redstone Minus Redstone is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Redstone Minus Redstone is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Redstone Minus Redstone.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.redstoneminus;

final class PowerTicker {
    private float[] values = new float[15];
    private int[] currRamp = new int[15];
    private int tick = 0;

    int[] tickRamp(float[] powerRamp) {
        if (((tick++) % RedstoneMinusRedstone.tickGrouping) > 0) {
            return null;
        }

        boolean hasPositive = false;

        for (int i = 0; i < 15; i++) {
            float val = powerRamp[i] * RedstoneMinusRedstone.tickGrouping;

            int p = (int) Math.floor(val);
            values[i] += (val - p);
            while (values[i] >= 1.0f) {
                p++;
                values[i] -= 1.0f;
            }
            currRamp[i] = p;
            if (p > 0) {
                hasPositive = true;
            }
        }

        return hasPositive ? currRamp : null;
    }
}
